/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Sun Microsystems, Inc.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * $RCSfile: XUpdateListener.idl,v $
 * $Revision: 1.10 $
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#ifndef __com_sun_star_form_XUpdateListener_idl__ 
#define __com_sun_star_form_XUpdateListener_idl__ 
 
#ifndef __com_sun_star_lang_XEventListener_idl__ 
#include <com/sun/star/lang/XEventListener.idl> 
#endif 
 
#ifndef __com_sun_star_lang_EventObject_idl__ 
#include <com/sun/star/lang/EventObject.idl> 
#endif 
 
 
//============================================================================= 
 
 module com {  module sun {  module star {  module form { 
 
//============================================================================= 
 
/** used to listen on objects which allow updating their data.
    <p>In addition to just get notified when an data update happened, the listener
    has a chance to veto updates <em>before</em> they happen.</p>
    
    @see XUpdateBroadcaster
 */
published interface XUpdateListener: com::sun::star::lang::XEventListener
{ 
    //------------------------------------------------------------------------- 
     
    /** is invoked to check the current data.

        <p>For a given update process, if one of the <type>XUpdateListener</type>s
        vetos the change, the update is canceled, and no further notification happens.</p>

        @param aEvent
            An event dedscriptor specifying the broadcaster of the change.

        @returns 
            <TRUE/> when the update was approved, otherwise <FALSE/>.
     */
    boolean approveUpdate( [in] com::sun::star::lang::EventObject aEvent ); 
 
    //------------------------------------------------------------------------- 
     
    /** is invoked when an object has finished processing the updates and
        the data has been successfully written.

        @param aEvent
            A event dedscriptor specifying the broadcaster of the change.
     */
    void updated( [in] com::sun::star::lang::EventObject aEvent ); 
 
}; 
 
//============================================================================= 
 
}; }; }; }; 
 
/*============================================================================= 
 
=============================================================================*/ 
#endif 
